## pocl 1.1

=== CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014-2017 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

project(pocl)
set(MAJOR_VERSION 1)
set(MINOR_VERSION 1)
set(VERSION_SUFFIX "")
set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}${VERSION_SUFFIX})
set(POCL_VERSION ${VERSION_STRING})

# required b/c SHARED libs defaults to ON while OBJECT defaults to OFF
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  set(DEFAULT_BUILD_TYPE "Debug")
else()
  set(DEFAULT_BUILD_TYPE "RelWithDebInfo")
endif()

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE
      STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

enable_testing()

##################################################################################

option(OCS_AVAILABLE "Online compiler support available to build pocl with. Default is available." ON)

option(BUILD_SHARED_LIBS "ON=Build shared libs, OFF=static libs" ON)

option(POCL_DEBUG_MESSAGES
  "Enable debug messages from pocl (useful for OpenCL developers), must be enabled at runtime, with env var POCL_DEBUG"
  ON)

option(ENABLE_HSA "Enable the HSA device driver for AMD GCN devices" OFF)

option(ENABLE_CUDA "Enable the CUDA device driver for NVIDIA devices" OFF)

option(KERNEL_CACHE_DEFAULT "Default value for the kernel compile cache. If disabled, pocl will still use the kernel cache, but will delete cachefiles on exit. You can still enable keeping the files it at runtime with an env var." ON)

option(POCL_ICD_ABSOLUTE_PATH "Use absolute path in pocl.icd" ON)

option(ENABLE_POCL_BUILDING "When OFF, env var POCL_BUILDING has no effect. Defaults to ON" ON)

#### these are mostly useful for pocl developers

option(DEVELOPER_MODE "This will SIGNIFICANTLY slow down pocl (but speed up its compilation). Only turn on if you know what you're doing." OFF)

option(USE_POCL_MEMMANAGER "Enables custom memory manager. Except for special circumstances, this should be disabled." OFF)

option(EXAMPLES_USE_GIT_MASTER "If enabled, some of the external testsuites in examples/ will try to use sources from Git master, instead of releases. This may result in failure to build or run the examples" OFF)

####

# currently only works with gcc as host compiler
if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
  if (CMAKE_C_COMPILER_VERSION VERSION_GREATER "4.7.99")
    option(ENABLE_ASAN "Enable AddressSanitizer" OFF)
    option(ENABLE_TSAN "Enable ThreadSanitizer" OFF)
  else()
    set(ENABLE_ASAN OFF CACHE INTERNAL "Enable AddressSanitizer")
    set(ENABLE_TSAN OFF CACHE INTERNAL "Enable ThreadSanitizer")
  endif()

  if (CMAKE_C_COMPILER_VERSION VERSION_GREATER "4.8.99")
    option(ENABLE_UBSAN "Enable UBSanitizer" OFF)
  else()
    set(ENABLE_UBSAN OFF CACHE INTERNAL "Enable UBSanitizer")
  endif()

  if (CMAKE_C_COMPILER_VERSION VERSION_GREATER "5.0.99")
    option(ENABLE_LSAN "Enable LeakSanitizer" OFF)
  else()
    set(ENABLE_LSAN OFF CACHE INTERNAL "Enable LeakSanitizer")
  endif()

endif()

##########################################################

# POCL_DEVICE_ADDRESS_BITS
# TODO rename to HOST address bits
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(POCL_DEVICE_ADDRESS_BITS 64)
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(POCL_DEVICE_ADDRESS_BITS 32)
else()
  message(FATAL_ERROR "Cannot figure out POCL_DEVICE_ADDRESS_BITS")
endif()

##################################################################################

if(CMAKE_SYSTEM_PROCESSOR MATCHES "ppc")
  set(POWERPC 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "mips")
  set(MIPS 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "armv7")
  set(ARMV7 1)
  set(ARM32 1)
  set(ARM 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "armv6")
  set(ARMV6 1)
  set(ARM32 1)
  set(ARM 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64")
  set(ARM64 1)
  set(ARM 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(i.86|AMD64|x86_64)")
  set(X86 1)
  if(POCL_DEVICE_ADDRESS_BITS MATCHES "32")
    set(I386 1)
  else()
    set(X86_64 1)
  endif()
endif()

if(CMAKE_MAJOR_VERSION GREATER 2)
  include(ProcessorCount)
  ProcessorCount(CORECOUNT)
  if(CORECOUNT LESS 1)
    set(CORECOUNT 1)
  endif()
else()
  set(CORECOUNT 1)
endif()
message(STATUS "Host CPU cores: ${CORECOUNT}")

######################################################################################

macro(set_expr VAR)
  if(${ARGN})
    set(${VAR} 1)
  else()
    set(${VAR} 0)
  endif()
endmacro()

function(rename_if_different SRC DST)
  if(EXISTS "${DST}")
    file(MD5 "${SRC}" OLD_MD5)
    file(MD5 "${DST}" NEW_MD5)
    if(NOT OLD_MD5 STREQUAL NEW_MD5)
      file(RENAME "${SRC}" "${DST}")
    endif()
  else()
    file(RENAME "${SRC}" "${DST}")
  endif()
endfunction()

######################################################################################

# Recent versions of CMake can make use of Ninja's console pool to avoid
# buffering the output of particular commands.
if(CMAKE_VERSION VERSION_LESS 3.2.0)
  set(COMMAND_USES_TERMINAL)
else()
  set(COMMAND_USES_TERMINAL USES_TERMINAL)
endif()

if(UNIX)
  include(GNUInstallDirs)
else()
  if (WIN32)
    set(${CMAKE_INSTALL_LIBDIR} "lib")
    set(${CMAKE_INSTALL_DATADIR} "share")
    set(${CMAKE_INSTALL_INCLUDEDIR} "include")
    set(${CMAKE_INSTALL_BINDIR} "bin")
    message(STATUS "Setting installation destination on Windows to: ${CMAKE_INSTALL_PREFIX}")
  else()
    message(FATAL_ERROR "System not UNIX nor WIN32 - not implemented yet")
  endif()
endif()

# for libpocl.so
set(POCL_INSTALL_PUBLIC_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" CACHE PATH "POCL public libdir")

# for llvmopencl.so
set(POCL_INSTALL_PRIVATE_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pocl" CACHE PATH "POCL private libdir")

# for pocl.icd
if(UNIX AND (NOT CMAKE_CROSSCOMPILING) AND (CMAKE_INSTALL_PREFIX STREQUAL "/usr"))
  set(POCL_INSTALL_ICD_VENDORDIR "/etc/OpenCL/vendors" CACHE PATH "POCL ICD file destination")
else()
  set(POCL_INSTALL_ICD_VENDORDIR "${CMAKE_INSTALL_PREFIX}/etc/OpenCL/vendors" CACHE PATH "POCL ICD file destination")
endif()

# for kernel-<target>.bc
set(POCL_INSTALL_PRIVATE_DATADIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/pocl" CACHE PATH "POCL private datadir")

# for poclu.h
set(POCL_INSTALL_PUBLIC_HEADER_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}" CACHE PATH "POCL public header dir")

# for _kernel.h et al
set(POCL_INSTALL_PRIVATE_HEADER_DIR "${POCL_INSTALL_PRIVATE_DATADIR}/include" CACHE PATH "POCL private header dir")

# for pocl-standalone et al
set(POCL_INSTALL_PUBLIC_BINDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}" CACHE PATH "POCL public bindir")

# for PoclConfig.cmake & stuff
set(POCL_INSTALL_CMAKE_CONFIG_DIR "${POCL_INSTALL_PRIVATE_LIBDIR}" CACHE PATH   "Installation directory for CMake files")

# TODO maybe use output of pkg-config --variable=pc_path pkg-config ?
set(POCL_INSTALL_PKGCONFIG_DIR "${POCL_INSTALL_PUBLIC_LIBDIR}/pkgconfig" CACHE PATH "Destination for pocl.pc")

if(APPLE)
  set(CMAKE_MACOSX_RPATH ON)
  set(POCL_INSTALL_OPENCL_HEADER_DIR "${POCL_INSTALL_PUBLIC_HEADER_DIR}/OpenCL" CACHE PATH "POCL header dir for OpenCL headers")
else()
  set(POCL_INSTALL_OPENCL_HEADER_DIR "${POCL_INSTALL_PUBLIC_HEADER_DIR}/CL" CACHE PATH "POCL header dir for OpenCL headers")
endif()

######################################################################################

if(UNIX)
  find_package(PkgConfig MODULE REQUIRED)
endif()

######################################################################################

set(ANDROID_COMPILER 0)
if(CMAKE_C_COMPILER MATCHES "android")
  set(ANDROID_COMPILER 1)
  add_definitions(-DPOCL_ANDROID)
  add_definitions(-DPOCL_ANDROID_PREFIX="/data/data/org.pocl.libs/files")
endif()

######################################################################################

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
find_package( Hwloc )

if(NOT Hwloc_FOUND)
  message(FATAL_ERROR "hwloc package is required!")
endif()

if("${Hwloc_VERSION}" VERSION_LESS "1.0")
  message(FATAL_ERROR "Hwloc version must be >= 1.0 !")
endif()

message(STATUS "Hwloc_VERSION ${Hwloc_VERSION}")
message(STATUS "Hwloc_LDFLAGS ${Hwloc_LDFLAGS}")
message(STATUS "Hwloc_CFLAGS ${Hwloc_CFLAGS}")

######################################################################################

if(NOT HOST_CPU_CACHELINE_SIZE)

  set(CL_SIZE 0)
  if(UNIX)
    find_program(GETCONF "getconf")
    if(GETCONF)
      execute_process(COMMAND "getconf" "LEVEL1_DCACHE_LINESIZE"
                      RESULT_VARIABLE RES OUTPUT_VARIABLE CL_SIZE)
      if(RES)
        message(WARNING "getconf exited with nonzero status!")
        set(CL_SIZE 0)
      else()
        # getconf sometimes just returns zero
        if(NOT (CL_SIZE EQUAL 0))
          message(STATUS "L1D Cacheline size detected: ${CL_SIZE}")
          set(HOST_CPU_CACHELINE_SIZE "${CL_SIZE}" CACHE STRING "L1D Cacheline size")
        endif()
      endif()
    endif()
  endif()

  if(CL_SIZE EQUAL 0)
    message(WARNING "Unable to detect cacheline size - assuming 64byte cacheline, override with -DHOST_CPU_CACHELINE_SIZE=<number> (Note: this is merely used for optimization, at worst pocl will be slightly slower)")
    set(HOST_CPU_CACHELINE_SIZE "64" CACHE STRING "L1D Cacheline size")
  endif()
endif()

######################################################################################
#
# Find executables to few tools required during build 
#

find_program(PATCH_EXEC
  NAMES patch${CMAKE_EXECUTABLE_SUFFIX}
  HINTS ENV PATH
)

find_program(XARGS_EXEC
  NAMES xargs${CMAKE_EXECUTABLE_SUFFIX}
  HINTS ENV PATH
)

if(NOT PATCH_EXEC)
  message(FATAL_ERROR "Could not find patch command.")
endif()

if(NOT XARGS_EXEC)
  message(FATAL_ERROR "Could not find xargs command.")
endif()

######################################################################################

if (OCS_AVAILABLE)

  include(LLVM RESULT_VARIABLE RES)
  if(NOT RES)
    message(FATAL_ERROR "Could not load LLVM.cmake")
  endif()

  if(NOT DEFINED HOST_DEVICE_BUILD_HASH)
    if(KERNELLIB_HOST_CPU_VARIANTS STREQUAL "distro")
      set(HOST_DEVICE_BUILD_HASH "${LLC_TRIPLE}")
    else()
      set(HOST_DEVICE_BUILD_HASH "${LLC_TRIPLE}-${LLC_HOST_CPU}")
    endif()
  endif()

  if(ARM AND LLVM_3_9)
    message(FATAL_ERROR "pocl does not build on ARM with LLVM 3.9 unless is was patched. Try LLVM 3.8 or (preferably) 4.0+")
  endif()

else()

  if(NOT DEFINED HOST_DEVICE_BUILD_HASH)
    message(FATAL_ERROR "For compiler-less builds, you must define HOST_DEVICE_BUILD_HASH")

=== examples/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

# to install system packages required for all examples:
#
# on Archlinux:
#    pacman -S blas cblas lapack lapacke openmpi svn  freeimage  python-numpy python2-numpy  python-mako python2-mako
#
# on Ubuntu:
#    apt-get install libblas-dev liblapack-dev  liblapacke-dev  libopenmpi-dev   subversion python-numpy python-mako
#

add_subdirectory("example1")
add_subdirectory("example2")
add_subdirectory("example2a")

if(HOST_DEVICE_EXTENSIONS MATCHES "spir")
  add_subdirectory("example1-spir32")
  add_subdirectory("example1-spir64")
endif()

add_subdirectory("poclcc")
if(ENABLE_FP64)
  add_subdirectory("scalarwave")
endif()
add_subdirectory("trig")
add_subdirectory("EinsteinToolkit")

# TODO:   opencl-book-samples
set(ALL_TESTSUITES
    AMD AMDSDK2.9 AMDSDK3.0
    ASL arrayfire clBLAS clFFT
    conformance CloverLeaf Halide IntelSVM
    opencl-book-samples OpenCV
    Parboil piglit PyOpenCL
    Rodinia VexCL ViennaCL)

if("${ENABLE_TESTSUITES}" STREQUAL "all")
  set(ENABLE_TESTSUITES ${ALL_TESTSUITES})
endif()

if("${ENABLE_TESTSUITES}" MATCHES "tier1")
  list(REMOVE_ITEM ENABLE_TESTSUITES "tier1")
  list(APPEND ENABLE_TESTSUITES "AMDSDK3.0" "piglit" "conformance")
endif()

include(ExternalProject)

# invoke this to build all examples
add_custom_target(prepare_examples)

find_program(BASH "bash")
find_program(MAKE_PROGRAM NAMES "make")
find_package(Git QUIET)
set_expr(HAVE_GIT GIT_EXECUTABLE)

if(ENABLE_TESTSUITES)

  unset(CMAKE_MODULE_PATH) # Use CMake builtin find module

  message(STATUS "Trying to enable testsuites: ${ENABLE_TESTSUITES}")

  set(ACTUALLY_ENABLED_TESTSUITES "")

  if(NOT DEFINED TESTSUITE_BASEDIR)
    # TODO maybe current src dir ?
    set(TESTSUITE_BASEDIR "${CMAKE_CURRENT_BINARY_DIR}")
  endif()
  if(NOT IS_DIRECTORY "${TESTSUITE_BASEDIR}")
    message(FATAL_ERROR "TESTSUITE_BASEDIR (${TESTSUITE_BASEDIR}) is not a directory.")
  endif()

  if(NOT DEFINED TESTSUITE_SOURCE_BASEDIR)
    set(TESTSUITE_SOURCE_BASEDIR "${CMAKE_CURRENT_SOURCE_DIR}")
  endif()
  if(NOT IS_DIRECTORY "${TESTSUITE_SOURCE_BASEDIR}")
    message(FATAL_ERROR "TESTSUITE_SOURCE_BASEDIR (${TESTSUITE_SOURCE_BASEDIR}) is not a directory.")
  endif()

  message(STATUS "Testsuite base dirs: ")
  message(STATUS "    binary: ${TESTSUITE_BASEDIR}")
  message(STATUS "    source: ${TESTSUITE_SOURCE_BASEDIR}")

  foreach(TESTSUITE IN LISTS ENABLE_TESTSUITES)
    list(FIND ALL_TESTSUITES ${TESTSUITE} INDEX)
    if(${INDEX} GREATER -1)
      if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${TESTSUITE}")
        add_subdirectory("${TESTSUITE}")
      else()
        message(FATAL_ERROR "Cannot find source dir for testsuite: ${TESTSUITE}")
      endif()
    else()
      message(WARNING "Unknown testsuite ${TESTSUITE} requested")
    endif()
  endforeach()

endif()

set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)
set(ALL_TESTSUITES ${ALL_TESTSUITES} PARENT_SCOPE)

set(DISABLED "${ALL_TESTSUITES}")
foreach(TS ${ACTUALLY_ENABLED_TESTSUITES})
  list(REMOVE_ITEM DISABLED ${TS})
endforeach()

set(DISABLED_TESTSUITES ${DISABLED} PARENT_SCOPE)

######################################################################################

if((ACTUALLY_ENABLED_TESTSUITES MATCHES "AMD") AND (NOT MSVC))

  pkg_check_modules(GLEW glew)

  if(GLEW_FOUND)
    set(HAVE_GLEW 1 PARENT_SCOPE)
  else()
    set(HAVE_GLEW 0 PARENT_SCOPE)
    message(WARNING "libGLEW not found. A few tests from AMD testsuite will not work")
  endif()

endif()

=== include/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

add_subdirectory("CL")

set(PRIVATE_HEADERS _enable_all_exts.h _builtin_renames.h _kernel.h _kernel_c.h _kernel_constants.h pocl_types.h pocl_device.h pocl.h)

install(FILES ${PRIVATE_HEADERS}
        DESTINATION ${POCL_INSTALL_PRIVATE_HEADER_DIR})

=== lib/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

separate_arguments(HOST_CLANG_FLAGS)
separate_arguments(HOST_LLC_FLAGS)

if (OCS_AVAILABLE)
  add_subdirectory("kernel")
  add_subdirectory("llvmopencl")
endif()

set(SANITIZER_OPTIONS "")

if(ENABLE_ASAN)
  if("${CMAKE_C_COMPILER_VERSION}" VERSION_LESS "5.1.0")
    list(APPEND SANITIZER_OPTIONS "-fsanitize=address")
  else()
    list(APPEND SANITIZER_OPTIONS "-fsanitize=address" "-fsanitize-recover=address")
  endif()
  list(APPEND SANITIZER_LIBS "asan")
endif()

if(ENABLE_LSAN)
  list(APPEND SANITIZER_OPTIONS "-fsanitize=leak")
  list(APPEND SANITIZER_LIBS "lsan")
endif()

if(ENABLE_TSAN)
  list(APPEND SANITIZER_OPTIONS "-fsanitize=thread")
  list(APPEND SANITIZER_LIBS "tsan")
endif()

if(ENABLE_UBSAN)
  list(APPEND SANITIZER_OPTIONS "-fsanitize=undefined")
  list(APPEND SANITIZER_LIBS "ubsan")
endif()

if(SANITIZER_OPTIONS)
  list(APPEND SANITIZER_OPTIONS "-fno-omit-frame-pointer")
  string(REPLACE ";" " " SANITIZER_OPTIONS_STR "${SANITIZER_OPTIONS}")
endif()

add_subdirectory("CL")

#############################################################

# must be after adding lib/CL subdir b/c of libpocl target,
# but before poclu & examples & tests (they need these variables)

if(ENABLE_ICD)

  # -pthread makes gdb happier when debugging tests
  set(OPENCL_LIBS "${PTHREAD_LIBRARY};${OPENCL_LIBRARIES}")

else()

  # when we link pocl directly as libOpenCL.so,
  # llvm+clang libs are a transitive dependency of
  # executables (e.g. poclcc -> libOpenCL -> libLLVM)
  # and this must be specified on new systems,
  # otherwise linking fails.
  set(OPENCL_LIBS "${PTHREAD_LIBRARY};${POCL_LIBRARY_NAME};${POCL_TRANSITIVE_LIBS}")

endif()

set(OPENCL_CFLAGS "")

if(SANITIZER_OPTIONS)
  list(INSERT OPENCL_LIBS 0 ${SANITIZER_LIBS})
  set(OPENCL_CFLAGS "${OPENCL_CFLAGS} ${SANITIZER_OPTIONS_STR}")
endif()

set(OPENCL_CFLAGS_STR "${OPENCL_CFLAGS}")
separate_arguments(OPENCL_CFLAGS)


set(OPENCL_LIBS "${OPENCL_LIBS}" PARENT_SCOPE)
set(OPENCL_CFLAGS "${OPENCL_CFLAGS}" PARENT_SCOPE)
set(OPENCL_CFLAGS_STR "${OPENCL_CFLAGS_STR}" PARENT_SCOPE)

set(SANITIZER_LIBS "${SANITIZER_LIBS}" PARENT_SCOPE)
set(SANITIZER_OPTIONS "${SANITIZER_OPTIONS}" PARENT_SCOPE)
set(SANITIZER_OPTIONS_STR "${SANITIZER_OPTIONS_STR}" PARENT_SCOPE)

add_subdirectory("poclu")

=== tests/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

add_test("pocl_version_check" "runtime/test_version")

set_tests_properties("pocl_version_check"
  PROPERTIES
  ENVIRONMENT "POCL_DEVICES=basic"
  PASS_REGULAR_EXPRESSION "basic"
  LABELS "internal;cuda")

#######################################################################

add_subdirectory("kernel")
add_subdirectory("regression")
add_subdirectory("runtime")
add_subdirectory("workgroup")
if(ENABLE_TCE)
  add_subdirectory("tce")
endif()

=== doc/sphinx/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PortableComputingLanguagepocl.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PortableComputingLanguagepocl.qhc"

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

publish_to_web:
	rsync -r build/html $(SOURCEFORGE_USER)@web.sourceforge.net:/home/project-web/pocl/htdocs/docs/

=== examples/AMD/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================


if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux" AND X86_64)

  set(TS_NAME AMD)
  set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
  set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
  set(AMD_APP_SDK_TGZ "${TS_SRCDIR}/AMD-APP-SDK-v2.8-RC-lnx64.tgz")

  if(EXISTS "${AMD_APP_SDK_TGZ}")

    message(STATUS "Enabling testsuite ${TS_NAME}")
    list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
    set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

    ExternalProject_Add(
      ${TS_NAME}
      PREFIX "${TS_BASEDIR}"
      DOWNLOAD_COMMAND "/bin/true"
      PATCH_COMMAND tar -xzf "${AMD_APP_SDK_TGZ}" && pwd && patch -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/AMDSDK.patch
      CONFIGURE_COMMAND "/bin/true"
      BUILD_IN_SOURCE 1
      BUILD_COMMAND "/bin/true"
      INSTALL_COMMAND "/bin/true"
    )

    set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
    add_dependencies(prepare_examples ${TS_NAME})

    set(AMD_SAMPLES
    AESEncryptDecrypt
    AtomicCounters
    BinarySearch
    BinomialOption
    BinomialOptionMultiGPU
    BitonicSort
    BlackScholes
    BlackScholesDP
    BoxFilter
    BufferBandwidth
    DCT
    DeviceFission
    DeviceFission11Ext
    DwtHaar1D
    FastWalshTransform
    FloydWarshall
    HelloWorld
    Histogram
    ImageOverlap
    KernelLaunch
    LUDecomposition
    Mandelbrot
    MatrixMulImage
    MatrixMultiplication
    MatrixTranspose
    MemoryModel
    MonteCarloAsian
    MonteCarloAsianMultiGPU
    NBody
    PrefixSum
    QuasiRandomSequence
    RadixSort
    RecursiveGaussian
    Reduction
    ScanLargeArrays
    SimpleConvolution
    SimpleImage
    SimpleMultiDevice
    SobelFilter
    Template
    TemplateC
    TransferOverlap
    URNG)

    # disabled tests:
    #   SimpleGL BoxFilterGL FluidSimulation2D GaussianNoiseGL
    #   MonteCarloAsianDP AdvancedMultiGPU BasicDebug ImageBandwidth

    foreach(SAMPLE IN LISTS AMD_SAMPLES)
      add_test(NAME "AMD_28_${SAMPLE}"
        COMMAND "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-v2.8-RC-lnx64/samples/opencl/bin/x86_64/${SAMPLE}" "-q" "-t" "-e"
        WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-v2.8-RC-lnx64/samples/opencl/bin/x86_64")
      set_tests_properties("AMD_28_${SAMPLE}" PROPERTIES LABELS "amdsdk_28")
    endforeach()

  else()
    message(STATUS "Disabling testsuite ${TS_NAME} - tarball not found")
  endif()

else()
  message(STATUS "AMD APP SDK testsuite is only enabled for x86_64 Linux systems currently")
endif()

=== examples/EinsteinToolkit/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

#AM_CPPFLAGS = -I$(top_srcdir)/fix-include -I$(top_srcdir)/include -DSRCDIR='"$(abs_srcdir)"'
add_definitions("-DSRCDIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"")

# EinsteinToolkit_CFLAGS = @OPENCL_CFLAGS@
#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 ${OPENCL_CFLAGS}")
add_compile_options(${OPENCL_CFLAGS} -std=c99)

if (MSVC)
  set_source_files_properties( EinsteinToolkit.c PROPERTIES LANGUAGE CXX )
endif(MSVC)
add_executable("EinsteinToolkit" EinsteinToolkit.c ML_BSSN_CL_RHS1.cl ML_BSSN_CL_RHS2.cl)

# EinsteinToolkit_LDADD = @OPENCL_LIBS@ ../../lib/poclu/libpoclu.la
target_link_libraries("EinsteinToolkit" ${POCLU_LINK_OPTIONS})

if(NOT MIPS)
  add_test(NAME "EinsteinToolkit" COMMAND "EinsteinToolkit")

  set_tests_properties( "EinsteinToolkit"
    PROPERTIES
    COST 15.0
    LABELS "EinsteinToolkit"
    DEPENDS "pocl_version_check")

  add_test(NAME "EinsteinToolkit_SubDev" COMMAND "EinsteinToolkit" s)

  set_tests_properties( "EinsteinToolkit_SubDev"
    PROPERTIES
    COST 15.0
    LABELS "EinsteinToolkit"
    ENVIRONMENT "POCL_AFFINITY=1"
    DEPENDS "pocl_version_check")
endif()

=== examples/IntelSVM/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME IntelSVM)
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
set(INTEL_ZIP "${TS_SRCDIR}/intel_ocl_svm_basic_win.zip")

if (EXISTS "${INTEL_ZIP}")
  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    DOWNLOAD_COMMAND /bin/true
    PATCH_COMMAND pwd && unzip "${INTEL_ZIP}" &&
      cp "${CMAKE_CURRENT_SOURCE_DIR}/intelsvm_CMakeLists.txt" ./CMakeLists.txt &&
      patch -p0 -d SVMBasicCoarseGrained -i ${CMAKE_CURRENT_SOURCE_DIR}/intelsvm.patch &&
      patch -p0 -d SVMBasicFineGrained -i ${CMAKE_CURRENT_SOURCE_DIR}/intelsvm.patch
    CMAKE_ARGS
      -DCMAKE_BUILD_TYPE=RelWithDebInfo
      "-DCMAKE_CXX_FLAGS_RELWITHDEBINFO=-O2 -g -DCL_USE_DEPRECATED_OPENCL_1_2_APIS"
      -DOPENCL_LIBRARIES:STRING=OpenCL
      "-DPOCL_OPENCL_HEADERS=${CMAKE_SOURCE_DIR}/include"
    INSTALL_COMMAND "/bin/true"
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  # LLVM 3.8 fails with
  # error: Explicit load/store type does not match pointee type of pointer operand
  # This seems to occur only with some LLVM built setups, so let's just skip
  # the tests completely.

  if(NOT LLVM_3_8)
    add_test(NAME intel_svm_coarse
      COMMAND "${TS_BUILDDIR}/coarse" -p 0 -t default
      WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/SVMBasicCoarseGrained")
    add_test(NAME intel_svm_fine
      COMMAND "${TS_BUILDDIR}/fine" -p 0 -t default
      WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/SVMBasicFineGrained")

    set_tests_properties(intel_svm_coarse intel_svm_fine
      PROPERTIES  LABELS "IntelSVM;hsa")
    set_tests_properties(intel_svm_coarse intel_svm_fine
      PROPERTIES  PASS_REGULAR_EXPRESSION "PASSED")

  endif()

else()

  message(STATUS "Disabling testsuite ${TS_NAME}, required files not found" )

endif()

=== examples/PyOpenCL/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME "PyOpenCL")
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TS_BASEDIR}/src/${TS_NAME}")

# TODO for whatever reason, compyte (required for running tests)
# is not included in pyopencl release tars. For now force using git
set(EXAMPLES_USE_GIT_MASTER 1)

if(EXAMPLES_USE_GIT_MASTER)
  set(FETCH_SOURCE
      GIT_REPOSITORY "https://github.com/inducer/pyopencl.git"
      GIT_SUBMODULES "pyopencl/compyte" "src/c_wrapper")
else()
  set(FETCH_SOURCE URL "https://github.com/inducer/pyopencl/archive/v2017.2.tar.gz")
endif()

if(NOT TESTS_USE_ICD)
  message(STATUS "Disabling testsuite ${TS_NAME}, requires ocl-icd")
elseif(NOT BASH)
  message(STATUS "Disabling testsuite ${TS_NAME}, can't find bash shell")
else()

find_program(VIRTUALENV NAMES "virtualenv")
find_program(PYTHON_INTERP NAMES python3 python2 python)

if(VIRTUALENV)

  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    ${FETCH_SOURCE}

    # have to use external scripts, because CMake has /bin/sh hardcoded,
    # and /bin/sh on Ubuntu is dash, which doesn't support "source"
    # command.
    CONFIGURE_COMMAND "${BASH}" "${CMAKE_CURRENT_SOURCE_DIR}/configure.sh"
      "${TS_BASEDIR}"
      "${TS_BUILDDIR}"
      "${TS_SRCDIR}"
      "${VIRTUALENV}"
      "${PYTHON_INTERP}"

    BUILD_COMMAND "${BASH}" "${CMAKE_CURRENT_SOURCE_DIR}/build.sh"
      "${TS_BASEDIR}"
      "${TS_BUILDDIR}"
      "${TS_SRCDIR}"

    INSTALL_COMMAND "${BASH}" "${CMAKE_CURRENT_SOURCE_DIR}/install.sh"
      "${TS_BASEDIR}"
      "${TS_BUILDDIR}"
      "${TS_SRCDIR}"

  )


  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME "PyOpenCL"
           COMMAND "${BASH}" "${CMAKE_CURRENT_SOURCE_DIR}/runtest.sh"
            "${TS_BASEDIR}"
            "${TS_BUILDDIR}"
            "${TS_SRCDIR}"
           )

  set_tests_properties("PyOpenCL"
    PROPERTIES
      ENVIRONMENT "PYOPENCL_NO_CACHE=1;PYOPENCL_TEST=portable"
      LABELS "PyOpenCL")

else()

  message(STATUS "Disabling testsuite ${TS_NAME}, requires python virtualenv")

endif()

endif()

=== examples/ViennaCL/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME "ViennaCL")
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
set(VIENNA "ViennaCL-1.7.0")
set(ViennaCL_TGZ "${TS_SRCDIR}/${VIENNA}.tar.gz")

if(EXAMPLES_USE_GIT_MASTER)
  set(FETCH_SOURCE GIT_REPOSITORY "https://github.com/viennacl/viennacl-dev.git")
else()
  set(FETCH_SOURCE URL "http://sourceforge.net/projects/viennacl/files/1.7.x/ViennaCL-1.7.1.tar.gz/download")
endif()

if(EXISTS "${ViennaCL_TGZ}")

  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    SOURCE_DIR "${TS_BASEDIR}/src/${VIENNA}"
    DOWNLOAD_COMMAND
      test -d "${TS_BASEDIR}/src/${VIENNA}/ViennaCLConfig.cmake" || tar xzf "${ViennaCL_TGZ}"
    PATCH_COMMAND patch -N -r- -p1 -i
      ${CMAKE_CURRENT_SOURCE_DIR}/vienna_170.patch || /bin/true
    UPDATE_COMMAND /bin/true
    CMAKE_ARGS
      -DCMAKE_BUILD_TYPE=RelWithDebInfo
      -DBUILD_TESTING:BOOL=ON
      -DBUILD_EXAMPLES:BOOL=ON
      -DENABLE_OPENCL:BOOL=ON
      -DENABLE_CUDA:BOOL=OFF
      -DENABLE_UBLAS:BOOL=OFF
      "-DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING=-g -O0 -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
    INSTALL_COMMAND /bin/true
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME viennacl_examples_amg
          COMMAND "${TS_BUILDDIR}/examples/tutorial/amg"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
#  add_test(NAME viennacl_examples_bandwidth_reduction
#          COMMAND "${TS_BUILDDIR}/examples/tutorial/bandwidth-reduction"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_custom_kernels
          COMMAND "${TS_BUILDDIR}/examples/tutorial/custom-kernels"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_blas1
          COMMAND "${TS_BUILDDIR}/examples/tutorial/blas1"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_custom_context
          COMMAND "${TS_BUILDDIR}/examples/tutorial/custom-context"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_bisect
          COMMAND "${TS_BUILDDIR}/examples/tutorial/bisect"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_fft
          COMMAND "${TS_BUILDDIR}/examples/tutorial/fft"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_iterative_custom
          COMMAND "${TS_BUILDDIR}/examples/tutorial/iterative-custom"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_matrix_free
          COMMAND "${TS_BUILDDIR}/examples/tutorial/matrix-free"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_nmf
          COMMAND "${TS_BUILDDIR}/examples/tutorial/nmf"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_viennacl_info
          COMMAND "${TS_BUILDDIR}/examples/tutorial/viennacl-info"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_wrap_host_buffer
          COMMAND "${TS_BUILDDIR}/examples/tutorial/wrap-host-buffer"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_scheduler
          COMMAND "${TS_BUILDDIR}/examples/tutorial/scheduler"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_libviennacl_tutorial
          COMMAND "${TS_BUILDDIR}/examples/tutorial/libviennacl-tutorial"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")

#  add_test(NAME viennacl_benchmarks_opencl_bench_opencl
#          COMMAND "${TS_BUILDDIR}/examples/benchmarks/opencl-bench-opencl"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
#  add_test(NAME viennacl_benchmarks_dense_blas_bench_opencl
#          COMMAND "${TS_BUILDDIR}/examples/benchmarks/dense_blas-bench-opencl"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")

#  add_test(NAME viennacl_tests_bisect_test_opencl
#          COMMAND "${TS_BUILDDIR}/tests/bisect-test-opencl"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_fft_1d_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/fft_1d-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_external_linkage_opencl
          COMMAND "${TS_BUILDDIR}/tests/external_linkage-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_blas3_solve_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/blas3_solve-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_fft_2d_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/fft_2d-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_libviennacl_blas1_test
          COMMAND "${TS_BUILDDIR}/tests/libviennacl_blas1-test"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_iterators_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/iterators-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_global_variables_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/global_variables-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_libviennacl_blas2_test
          COMMAND "${TS_BUILDDIR}/tests/libviennacl_blas2-test"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_libviennacl_blas3_test
          COMMAND "${TS_BUILDDIR}/tests/libviennacl_blas3-test"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_col_double_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_col_double-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_col_float_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_col_float-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_col_int_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_col_int-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_product_double_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_product_double-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_convert_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_convert-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_product_float_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_product_float-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_row_double_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_row_double-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_row_float_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_row_float-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_row_int_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_row_int-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_vector_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_vector-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_nmf_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/nmf-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_scalar_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/scalar-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_vector_int_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_vector_int-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_qr_method_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/qr_method-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_qr_method_func_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/qr_method_func-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_scan_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/scan-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_self_assign_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/self_assign-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_sparse_prod_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/sparse_prod-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_sparse_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/sparse-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_structured_matrices_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/structured-matrices-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_spmdm_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/spmdm-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
#  add_test(NAME viennacl_tests_svd_test_opencl
#          COMMAND "${TS_BUILDDIR}/tests/svd-test-opencl"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_tql_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/tql-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_convert_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/vector_convert-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_float_double_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/vector_float_double-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_multi_inner_prod_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/vector_multi_inner_prod-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_int_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/vector_int-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_uint_test_opencl

=== examples/arrayfire/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME "arrayfire")
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")

find_package(LAPACK QUIET)
find_package(Boost QUIET)

if(EXAMPLES_USE_GIT_MASTER)
  set(FETCH_SOURCE GIT_REPOSITORY "https://github.com/arrayfire/arrayfire.git")
else()
  set(FETCH_SOURCE URL "http://arrayfire.com/arrayfire_source/arrayfire-full-3.5.1.tar.bz2")
endif()

if(HAVE_GIT)

if(LAPACK_FOUND AND
   Boost_FOUND AND (NOT Boost_VERSION VERSION_LESS "1.48"))

  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    ${FETCH_SOURCE}
    #PATCH_COMMAND  pwd && sed -i "s/CL_DEVICE_TYPE_GPU/CL_DEVICE_TYPE_CPU/g" *.cpp
    #UPDATE_COMMAND /bin/true
    CMAKE_ARGS
      -DBUILD_GRAPHICS=OFF
      -DBUILD_CUDA=OFF
      -DBUILD_CPU=OFF
      -DBUILD_OPENCL=ON
      -DCMAKE_BUILD_TYPE=RelWithDebInfo
      "-DCMAKE_C_FLAGS_RELWITHDEBINFO=-O2 -g -DCL_USE_DEPRECATED_OPENCL_1_2_APIS -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
      "-DCMAKE_CXX_FLAGS_RELWITHDEBINFO=-O2 -g -DCL_USE_DEPRECATED_OPENCL_1_2_APIS -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
    INSTALL_COMMAND /bin/true
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME arrayfire_tests_approx1_opencl
           COMMAND "${TS_BUILDDIR}/test/approx1_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_approx2_opencl
           COMMAND "${TS_BUILDDIR}/test/approx2_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_array_opencl
           COMMAND "${TS_BUILDDIR}/test/array_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_assign_opencl
           COMMAND "${TS_BUILDDIR}/test/assign_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_backend_opencl
           COMMAND "${TS_BUILDDIR}/test/backend_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_basic_c_opencl
           COMMAND "${TS_BUILDDIR}/test/basic_c_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_basic_opencl
           COMMAND "${TS_BUILDDIR}/test/basic_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_bilateral_opencl
           COMMAND "${TS_BUILDDIR}/test/bilateral_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_binary_opencl
           COMMAND "${TS_BUILDDIR}/test/binary_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_blas_opencl
           COMMAND "${TS_BUILDDIR}/test/blas_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_cholesky_dense_opencl
           COMMAND "${TS_BUILDDIR}/test/cholesky_dense_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_complex_opencl
           COMMAND "${TS_BUILDDIR}/test/complex_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_constant_opencl
           COMMAND "${TS_BUILDDIR}/test/constant_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_convolve_opencl
           COMMAND "${TS_BUILDDIR}/test/convolve_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_corrcoef_opencl
           COMMAND "${TS_BUILDDIR}/test/corrcoef_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_covariance_opencl
           COMMAND "${TS_BUILDDIR}/test/covariance_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_diagonal_opencl
           COMMAND "${TS_BUILDDIR}/test/diagonal_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_diff1_opencl
           COMMAND "${TS_BUILDDIR}/test/diff1_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_diff2_opencl
           COMMAND "${TS_BUILDDIR}/test/diff2_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_dog_opencl
           COMMAND "${TS_BUILDDIR}/test/dog_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_dot_opencl
           COMMAND "${TS_BUILDDIR}/test/dot_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fast_opencl
           COMMAND "${TS_BUILDDIR}/test/fast_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fft_large_opencl
           COMMAND "${TS_BUILDDIR}/test/fft_large_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fft_opencl
           COMMAND "${TS_BUILDDIR}/test/fft_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fft_real_opencl
           COMMAND "${TS_BUILDDIR}/test/fft_real_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fftconvolve_opencl
           COMMAND "${TS_BUILDDIR}/test/fftconvolve_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_flat_opencl
           COMMAND "${TS_BUILDDIR}/test/flat_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_flip_opencl
           COMMAND "${TS_BUILDDIR}/test/flip_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gaussiankernel_opencl
           COMMAND "${TS_BUILDDIR}/test/gaussiankernel_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gen_assign_opencl
           COMMAND "${TS_BUILDDIR}/test/gen_assign_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gen_index_opencl
           COMMAND "${TS_BUILDDIR}/test/gen_index_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_getting_started_opencl
           COMMAND "${TS_BUILDDIR}/test/getting_started_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gfor_opencl
           COMMAND "${TS_BUILDDIR}/test/gfor_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gradient_opencl
           COMMAND "${TS_BUILDDIR}/test/gradient_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_hamming_opencl
           COMMAND "${TS_BUILDDIR}/test/hamming_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_homography_opencl
           COMMAND "${TS_BUILDDIR}/test/homography_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_hsv_rgb_opencl
           COMMAND "${TS_BUILDDIR}/test/hsv_rgb_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_iir_opencl
           COMMAND "${TS_BUILDDIR}/test/iir_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_imageio_opencl
           COMMAND "${TS_BUILDDIR}/test/imageio_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_index_opencl
           COMMAND "${TS_BUILDDIR}/test/index_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_info_opencl
           COMMAND "${TS_BUILDDIR}/test/info_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_inverse_dense_opencl
           COMMAND "${TS_BUILDDIR}/test/inverse_dense_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_iota_opencl
           COMMAND "${TS_BUILDDIR}/test/iota_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_ireduce_opencl
           COMMAND "${TS_BUILDDIR}/test/ireduce_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_jit_opencl
           COMMAND "${TS_BUILDDIR}/test/jit_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_join_opencl
           COMMAND "${TS_BUILDDIR}/test/join_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_lu_dense_opencl
           COMMAND "${TS_BUILDDIR}/test/lu_dense_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_match_template_opencl
           COMMAND "${TS_BUILDDIR}/test/match_template_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_math_opencl
           COMMAND "${TS_BUILDDIR}/test/math_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_matrix_manipulation_opencl
           COMMAND "${TS_BUILDDIR}/test/matrix_manipulation_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_mean_opencl
           COMMAND "${TS_BUILDDIR}/test/mean_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_meanshift_opencl
           COMMAND "${TS_BUILDDIR}/test/meanshift_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_medfilt_opencl
           COMMAND "${TS_BUILDDIR}/test/medfilt_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
# takes too long
#  add_test(NAME arrayfire_tests_median_opencl
#           COMMAND "${TS_BUILDDIR}/test/median_opencl"
#           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_memory_lock_opencl
           COMMAND "${TS_BUILDDIR}/test/memory_lock_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_memory_opencl
           COMMAND "${TS_BUILDDIR}/test/memory_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_missing_opencl
           COMMAND "${TS_BUILDDIR}/test/missing_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_moddims_opencl
           COMMAND "${TS_BUILDDIR}/test/moddims_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_morph_opencl
           COMMAND "${TS_BUILDDIR}/test/morph_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")

=== debian/changelog ===
pocl (1.1-5) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 09 Apr 2018 14:42:39 +0200

pocl (1.1-4) experimental; urgency=medium

  * Run clinfo during testing.
  * Do not link with --rtlib=compiler-rt on non-x86.  (Closes: #892426)
  * Prevent PIC/no-PIC option clash on mips64el.
  * Set target cpu for armel to arm946e-s (arch=armv5te).
  * Set target cpu for armhf to arm1156t2f-s (arch=armv6t2) with
    -mfpu=vfp3-d16. Probably suboptimal (should rather be arch=armv7-a without
    neon,vfp4), but passes all tests.  (Closes: #888063)
  * Bump Standards-Version to 4.1.4, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 06 Apr 2018 19:39:01 +0200

pocl (1.1-3) experimental; urgency=medium

  * Add support for building for the GENERIC cpu, i.e. llvm defaults.
  * Build with -DLLC_HOST_CPU=GENERIC on most architectures.
  * Build with -DKERNELLIB_HOST_CPU_VARIANTS=distro on amd64.
  * Switch to llvm 6.0.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 27 Mar 2018 13:12:40 +0200

pocl (1.1-2) experimental; urgency=medium

  * Switch to llvm 5.0.
  * Update symbols files for amd64 and i386.
  * Cherry-pick upstream commits for libhwloc 2.0 support.
  * Cherry-pick upstream commit fixing test_clCreateSubDevices with 3 CUs.
  * Cherry-pick upstream commit fixing reported values of native/preferred
    vector width for unsupported types.
  * pocl-doc: Mark as Multi-Arch: foreign.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 25 Mar 2018 17:35:44 +0200

pocl (1.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove patches, applied or fixed upstream.
  * Remove -DFORCE_OCL_KERNEL_TARGET_CPU=ON, fixed upstream.
  * Report the error code on test failure.
  * Point watch file to git tags on github.
  * Add debian/upstream/metadata.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 10 Mar 2018 00:37:43 +0100

pocl (1.1~rc2-1) experimental; urgency=medium

  * New upstream release candidate.  (Closes: #888062)
  * Remove patches that were applied upstream.
  * Update symbols files.
  * Do not attempt to run the testsuite during an arch-indep build.
  * Set LLVM_ARCH for arm64, armel, armhf to generic.
  * Set LLVM_ARCH for s390x to z10.  (Closes: #888064)
  * Drop internal helper library packages libpoclu-dev and libpoclu2.
  * Add altivec.patch to get rid of the conflicting bool and vector macros
    from altivec.h.  (Closes: #764561)
  * Update Lintian overrides.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 27 Feb 2018 17:31:09 +0100

pocl (1.0-2) unstable; urgency=medium

  * Merge changes from 0.14-7.
  * Build with SLEEF instead of VECMATHLIB.
  * HACK: Ignore test failure for kernel/test_fabs on i386.
  * Add and use new CMake option -DFORCE_OCL_KERNEL_TARGET_CPU=ON.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 19 Jan 2018 01:11:11 +0100

pocl (1.0-1) experimental; urgency=medium

  * New upstream release.
  * Refresh/remove patches.
  * Build with -DPOCL_ICD_ABSOLUTE_PATH=OFF.
  * Rename library packages for SOVERSION bump: 1 => 2.
  * Update symbols files for amd64 and i386.
  * Build with -DENABLE_VECMATHLIB=ON.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Jan 2018 14:13:19 +0100

pocl (0.14-7) unstable; urgency=medium

  * Switch to llvm 4.0.  (Closes: #873417)
  * Update symbols files for amd64 and i386.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Jan 2018 18:36:08 +0100

pocl (0.14-6) unstable; urgency=medium

  * Switch to debhelper compat level 11.
  * Bump Standards-Version to 4.1.3, no changes needed.
  * Switch Vcs-* to salsa.debian.org.
  * Remove superfluous patches.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Jan 2018 06:13:22 +0100

pocl (0.14-5) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 18 Dec 2017 01:44:17 +0100

pocl (0.14-4) experimental; urgency=medium

  * Switch to llvm 3.9.
  * Update symbols files for amd64 and i386.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 16 Dec 2017 05:24:25 +0100

pocl (0.14-3) experimental; urgency=medium

  * Cherry-pick upstream [c9d2cd15] "llvm/Flatten: switch back to
    force-inlining only some funcs", fixing kernel/test_convert_type_* failing
    on i386 with LLC_HOST_CPU=i686.
  * Switch LLC_HOST_CPU from "pentium3" to the correct baseline "i686" on
    i386.
  * kernel/test_printf actually passes on i386 with LLC_HOST_CPU=i686.
  * Only override POCL_CACHE_DIR for the testsuite, not HOME.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 15 Dec 2017 07:08:32 +0100

pocl (0.14-2) experimental; urgency=medium

  * Cherry-pick upstream [62b74d6f] "Fix malloc size in tests/runtime/
    test_clBuildProgram.c", fixing runtime/clBuildProgram failing frequently
    on i386.
  * Try to guess the minimal cpu for more architectures.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 14 Dec 2017 01:37:41 +0100

pocl (0.14-1) experimental; urgency=medium

  * New upstream release.
  * The autotools based build system is gone.
  * Refresh/remove patches.
  * Use the CMAKE_INSTALL_SYSCONFDIR setting for /etc.
  * Update symbols files.
  * Update copyright holders and years.
  * Remove pocl-standalone(1) manpage. The binary is no longer shipped.
  * Ship the new poclcc binary in libpocl-dev.
  * Do not downgrade to -std=c++11, fixing test_fabs failing on i386.
    (Closes: #883613)
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Dec 2017 03:48:35 +0100

pocl (0.13-14) unstable; urgency=medium

  * Bump Standards-Version to 4.1.2, no changes needed.
  * cmake-no-get_cpu_name.patch: Rename/redo as
    cmake-no-llvm-sys-getHostCPUName.patch to not use
    llvm::sys::getHostCPUName().
  * Clean up generated include/CL/cl.hpp* to fix building twice in a row.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 08 Dec 2017 18:55:52 +0100



=== debian/control ===
Source: pocl
Section: libs
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Vincent Danjean <vdanjean@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper (>= 11~),
 pkg-config,
 libhwloc-dev,
 libltdl-dev,
 ocl-icd-dev (>= 2.2.3),
 ocl-icd-libopencl1 (>= 2.2.3),
 ocl-icd-opencl-dev,
 clang-6.0,
 libclang-6.0-dev,
 llvm-6.0-dev,
 pkg-kde-tools,
 sphinx-common,
 cmake,
 clinfo,
Build-Depends-Indep:
 python3-sphinx,
Rules-Requires-Root: no
Standards-Version: 4.1.4
Homepage: http://portablecl.org
Vcs-Browser: https://salsa.debian.org/opencl-team/pocl
Vcs-Git: https://salsa.debian.org/opencl-team/pocl.git

Package: pocl-opencl-icd
Architecture: any
Depends:
 libpocl2 (= ${binary:Version}),
 ${misc:Depends}
Provides:
 opencl-icd,
 opencl-icd-1.1-1,
 opencl-icd-1.2-1,
Description: pocl ICD
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package allows one to use pocl as an installable client driver (ICD) for
 OpenCL.

Package: libpocl2-common
Architecture: all
Multi-Arch: foreign
Section: utils
Depends:
 ${misc:Depends}
Breaks:
 libpocl1-common,
Replaces:
 libpocl1-common,
Description: common files for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the architecture independent files of the pocl library.

Package: libpocl2
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libpocl2-common (= ${source:Version}),
 clang-${LLVM:Version},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 pocl-opencl-icd,
Breaks:
 libpocl1-common (<< 0.13-9),
Replaces:
 libpocl1-common (<< 0.13-9),
Built-Using:
 ${Built-Using:clang},
Description: Portable Computing Language library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the core of pocl.

Package: libpocl-dev
Architecture: any
Section: libdevel
Depends:
 libpocl2 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: development files for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl library. Unless very
 specific needs, this package is useless. This package is only required to link
 directly and explicitly with pocl.
 .
 To develop OpenCL programs (that can be run with pocl), the opencl-dev virtual
 package (provided by ocl-icd-opencl-dev for example) is required, not this one.

Package: pocl-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl library.  Unless very
 specific needs, this package is useless.  This package is only required to link
 directly and explicitly with pocl.
 .
 This package provides the documentation for the pocl library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# When updating this variable, do not forget to adapt the build-depends
# in debian/control
LLVM_VERSION=6.0

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

LLVM_ARCH-amd64			 = distro
#LLVM_ARCH-amd64			 = x86-64
#LLVM_ARCH-arm64			 = generic
LLVM_ARCH-armel			 = arm946e-s		# arch=armv5te
# armhf should rather be arch=armv7-a, e.g. cpu=cortex-a5 or similar with attr=+vfp3,+d16,+thumb2,-neon,-vfp4
LLVM_ARCH-armhf			 = arm1156t2f-s
LLVM_ARCH-hurd-i386		 = $(LLVM_ARCH-i386)
LLVM_ARCH-i386			 = i686			# clang targets pentium4 by default
LLVM_ARCH-kfreebsd-amd64	 = $(LLVM_ARCH-amd64)
LLVM_ARCH-kfreebsd-i386		 = $(LLVM_ARCH-i386)
#LLVM_ARCH-mips			 = mips32r2 # guess
#LLVM_ARCH-mips64el		 = mips64r2 # guess
#LLVM_ARCH-mipsel		 = mips32r2 # guess
#LLVM_ARCH-powerpc		 = ppc
#LLVM_ARCH-ppc64			 = ppc64 # guess
#LLVM_ARCH-ppc64el		 = ppc64le
#LLVM_ARCH-s390x			 = z10
#LLVM_ARCH-sparc64		 = v8 # guess
LLVM_ARCH-x32			 = $(LLVM_ARCH-amd64)

LLC_HOST_CPU	 = $(or $(patsubst pocl_cpu=%,%,$(filter pocl_cpu=%,$(DEB_BUILD_OPTIONS))),$(LLVM_ARCH-$(DEB_HOST_ARCH)),GENERIC)

ifeq ($(DEB_HOST_ARCH),armhf)
# NEON, optional for Debian, must not be used
EXTRA_HOST_CLANG_FLAGS	 = -mfpu=vfp3-d16
# TODO: export KERNEL_LIB_OPT_FLAGS= -mattr=-neon,+d16,+vfp3,-vfp4,+v7,+aclass,+thumb2
endif

# doc for symbols:
# http://www.eyrie.org/~eagle/journal/2012-01/008.html
# main packaging script based on dh7 syntax
%:
	dh $@ --with pkgkde_symbolshelper --with sphinxdoc --buildsystem=cmake

var2flag		 = $(if $(strip $($1)),-D$1="$($1)")
POCL_CONFIGURE_FLAGS	 =
POCL_CONFIGURE_FLAGS	+= -DENABLE_ICD=yes
POCL_CONFIGURE_FLAGS	+= -DWITH_LLVM_CONFIG=/usr/bin/llvm-config-$(LLVM_VERSION)
POCL_CONFIGURE_FLAGS	+= $(if $(filter distro,$(LLC_HOST_CPU)),-DLLC_HOST_CPU=GENERIC -DKERNELLIB_HOST_CPU_VARIANTS=distro,-DLLC_HOST_CPU=$(LLC_HOST_CPU))
POCL_CONFIGURE_FLAGS	+= $(call var2flag,EXTRA_HOST_CLANG_FLAGS)
POCL_CONFIGURE_FLAGS	+= -DPOCL_ICD_ABSOLUTE_PATH=OFF

override_dh_auto_configure:
	@echo Using LLC_HOST_CPU=$(LLC_HOST_CPU)
	-/usr/lib/llvm-$(LLVM_VERSION)/bin/llc -version
	-/usr/lib/llvm-$(LLVM_VERSION)/bin/llc -mattr=help
	dh_auto_configure -- $(POCL_CONFIGURE_FLAGS)

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	sphinx-build -N -b html doc/sphinx/source build-doc/html
else
	mkdir -p build-doc/html
endif

override_dh_shlibdeps:
	dh_shlibdeps -a -- --warnings=7

override_dh_missing:
	dh_missing --list-missing

override_dh_auto_test-indep:
override_dh_auto_test-arch:
	# Failure in testsuite is delayed until symbols handling
	# and all files are logged.
	$(RM) debian/stamp-failed-testsuite
	$(RM) -r debian/kcache
	mkdir debian/kcache
	env POCL_CACHE_DIR=$(CURDIR)/debian/kcache \
		OCL_ICD_VENDORS=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/ocl-vendors/pocl-tests.icd \
		POCL_BUILDING=1 POCL_DEVICES=basic clinfo
	env POCL_CACHE_DIR=$(CURDIR)/debian/kcache \
		OCL_ICD_VENDORS=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/ocl-vendors/pocl-tests.icd \
		POCL_BUILDING=1 clinfo
	@set -ex; if ! env POCL_CACHE_DIR="$(CURDIR)/debian/kcache" dh_auto_test ; then \
		echo "***** The testsuite has failed! *****" ; \
		touch debian/stamp-failed-testsuite; \
	fi
	$(RM) -r debian/kcache

run_dh_makeshlibs:
	dh_makeshlibs

delayed_check_dh_auto_test_result: run_dh_makeshlibs
	@set -ex; if test -f debian/stamp-failed-testsuite ; then \
		echo "***** The testsuite has failed! *****" ; \
		exit 1 ; \
	fi
	@test -f obj-*/Testing/Temporary/LastTest.log && echo 'The testsuite has passed all tests.' || echo '*** The testsuite was *NOT* run! ***'

override_dh_makeshlibs: run_dh_makeshlibs delayed_check_dh_auto_test_result

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'LLVM:Version=$(LLVM_VERSION)' \
	        -V'Built-Using:clang=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libclang-$(LLVM_VERSION)-dev)' \


fix-symbols:
	pkgkde-getbuildlogs
	echo "pkgkde-symbolshelper batchpatch -v $(DEB_VERSION_EPOCH_UPSTREAM) pocl_$(DEB_DISTRIBUTION)_logs/pocl_$(DEB_VERSION)_*build"
